vs.1.1		// version instruction

//	r0: Transformed Normal
//	r1: Dot Product between the normal and the Light 1 Vector (N.L1)
//	r2:	Diffuse colour from light 1 Source
//	r3: Transformed vertex position
//	r4:	Transformed and Normalized Light 1 Vector
//	r5:	Transformed and Normalized Light 2 Vector
//	r6: Dot Product between the normal and the Light 2 Vector (N.L2)
//	r7:	Diffuse colour from light 2 Source
//	r8: Final Colour
//	c4: Material Diffuse Color
//	c5: Light1 Position
//	c6:	Light Colour
//	c7:	Light2 Position
//	c9:	Light2 Colour

// declare register data
dcl_position v0				//	v0 Vertex position
dcl_normal v4               //	v4 Vertex normal
dcl_texcoord0 v8            //	v8 Vertex texture coordinates

def c8, 0, 1, 0, 1	//	Light 2 Colour

m4x4 r3, v0, c0		//	Transform vertices to Model-View-Projection space
mov oPos, r3		//

m3x3 r0, v4, c0		//	Transform the normal to Model-View-Projection space
dp3 r0.w, r0, r0	//	Renormalize for safety
rsq r0.w, r0.w
mul r0, r0, r0.w

sub r4, c5, r3		//	Calculate Light 1 Vector ( L1 - V )
dp3 r4.w, r4, r4	//	Normalize it
rsq r4.w, r4.w
mul r4, r4, r4.w

sub r5, c7, r3		//	Calculate Light 2 Vector ( L2 - V )
dp3 r5.w, r5, r5	//	Normalize it
rsq r5.w, r5.w
mul r5, r5, r5.w

dp3 r1, r0, r4		//	Dot( Normal, Light1Vec ): N.L1
mul r2, r1, c4		//	Multiply the Dot product by the diffuse term(material's diffuse).
mul r2, c6, r2		//	Multiply result by light1 colour


dp3 r6, r0, r5		//	Dot( Normal, Light2Vec ): N.L2
mul r7, r6, c4		//	Multiply the Dot product by the diffuse term(material's diffuse).
mul r7, c8, r7		//	Multiply result by light2 colour

add r8, r2, r7		//	Add the two lights together

mov oD0, r8			//	Move final colour to output


