vs.1.1					// version instruction

//	r0: Transformed Vertex Position
//	r1: Transformed and reNormalized normal
//	r2:	Normalized Light Vector
//	r3: Diffuse Color
//	r4:	Transformed and Normalized Light Vector
//	r5: N.L
//	r6: Half Vector H= (L+V)/2
//	r7: Specular color
//	c5: Light Position
//	c17:Used for division by 2
//	c18:Light Colour

dcl_position v0             // declare register data
dcl_normal v4               // v0 is position, v4 is normal
dcl_texcoord0 v8            // v8 is texture coordinates

def c10, 0, 0, -1, 1	//	Cam Pos:	c10
def c11, 1, 1, 1, 1	//	Ones:		c11

def c17, 0.5, 0.5, 0.5, 1
def c18, 1.0, 0.0, 0.0, 1

//	Calculate Transformed position
m4x4 r0, v0, c0		//	Trasformed Vertex:	R0
mov oPos, r0		//	Output Position		oPos

//	Calculate Transformed Normal
m3x3 r1, v4, c0		//	Transformed Normal:	R1
mov r1.w, c11.x		//	Fill W coord

dp3 r8, r1, r1		//	Normalize normal
rsq r8, r8			//	...
mul r1, r1, r8		//	...

//	Calculate Normalized Light1 Vector
sub r2, c5, r0		//	Light1 vector:	R2
dp3 r8, r2, r2		//	Normalize Light1 Vector
rsq r8, r8			//	...
mul r2, r2, r8		//	...

//	Calculate Diffuse
dp3 r5, r1, r2		//	Nornal Dot Light1 (N.L): R5
mul r3, r5, c18		//	* Color.	Diffuse Color: R3

//	Calculate View Vector
sub r4, c10, r0		//	View Vector: R4
dp3 r8, r4, r4		//	and normalize it..
rsq r8, r8			//	...
mul r4, r4, r8		//	...

// * * * * * BLINN SPECULAR * * * * * //

add r6, r2, r4		//	L+V:	R6
mul r6, r6, c17		//	Half vector = (L+V)/2

//	Calculate specular
dp3 r7, r1, r6
mul r7, r7, r7
mul r7, r7, r7
mul r7, r7, r7

add oD0, r3, r7		//	R7 Specular, R3 Diffuse