vs.1.1		// version instruction

//	r0: Transformed Normal
//	r1: Dot Product between the normal and the Light Vector (N.L)
//	r2:	Final Colour
//	r3: Transformed vertex position
//	r4:	Transformed and Normalized Light Vector
//	c4: Material Diffuse Color
//	c5: Light Position
//	c6:	Light Colour

// declare register data
dcl_position v0				//	v0 Vertex position
dcl_normal v4               //	v4 Vertex normal
dcl_texcoord0 v8            //	v8 Vertex texture coordinates

m4x4 r3, v0, c0		//	Transform vertices to Model-View-Projection space
mov oPos, r3		//

m3x3 r0, v4, c0		//	Transform the normal to Model-View-Projection space
dp3 r0.w, r0, r0	//	Renormalize for safety
rsq r0.w, r0.w
mul r0, r0, r0.w

sub r4, c5, r3		//	Calculate Light Vector ( L - V )
dp3 r4.w, r4, r4	//	Normalize it
rsq r4.w, r4.w
mul r4, r4, r4.w

dp3 r1, r0, r4		//	Dot( Normal, LightVec ): N.L

mul r2, r1, c4		//	Multiply the light colour by the diffuse term(material's diffuse).
mul r2, c6, r2		//	Multiply result by light colour

mov oD0, r2			//	Move final colour to output


