vs.1.1		// version instruction

//	r0: Transformed Normal
//	r3: Transformed vertex position
//	r4: View Vector	(normalized)
//	r5: View Reflection Reflection
//	r8: Vertex Texture Coords

// declare register data
dcl_position v0				//	v0 Vertex position
dcl_normal v4               //	v4 Vertex normal
dcl_texcoord0 v8            //	v8 Vertex texture coordinates

def c17, 2, 2, 2, 1	//	Twos:		c17
def c18, 1, 1, 1, 1	//	Ones:		c18
def c20, 0.5, 0.5, 0.5, 0.5

m4x4 r3, v0, c0		//	Transform vertices to Model-View-Projection space
mov oPos, r3		//

m3x3 r0, v4, c0		//	Transform the normal to Model-View-Projection space
dp3 r0.w, r0, r0	//	Renormalize for safety
rsq r0.w, r0.w
mul r0, r0, r0.w

//	Calculate View Vector
sub r4, c14, r3		//	View Vector: R4
dp3 r8, r4, r4		//	and normalize it..
rsq r8, r8			//	...
mul r4, r4, r8		//	...

dp3 r5, r0, r4		//	N.V
mul r5, r5, c17		//	2*(N.V)
mul r5, r5, r0		//	2*(N.V)*N
sub r5, r5, r4		//	2*(N.V)*N - V
mov r5, -r5			//	Reflection = V - 2*(N.V)*N

add r5.z, r5.z, c18.z	//	Vr.z += 1

dp3 r6, r5, r5			//	Vr.Vr
rsq r7, r6				//	r7 = 1/(sqrt(Vr.Vr)

mul r7, r7, c20		//	r7 = 1/(2*sqrt(Vr.Vr))
mul r8, r5, r7		//	r8 = Vr * r7
add r8, r8, c20		//	r8 = r8 + [0.5,0.5]

mov oT0, r8

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//
//	Reference: Real-time Rendering (second edition) -	Tomas Akenine-Moller
//														Eric Heines
//
//	TexCoords:
//				U: R.x/2*m + 0.5
//				V: R.y/2*m + 0.5
//
//	Where:
//				m = SQRT( (R.x)^2 + (R.y)^2 + (R.z + 1)^2)
//				and
//				View Reflection Vector: R = E - 2*(N.E)*N
//				
//				Where:
//						E: Normalized vector from the eye to the surface location
//						N: Surface Normal
//
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -