vs.1.1		// version instruction

//	r0: Transformed Normal
//	r2:	Dot Product between the normal and the View Vector (N.V)
//	r3: Transformed vertex position
//	r4: Colour 1
//	r5: Colour 2
//	r6: Colour2 - Colour1
//	r7: interpolation*(colour2-colour1)
//	r8: Final Colour : LERP = colour1 + interpolation*(colour2-colour1)
//	c16:Colour 1
//	c17:Colour 2
//	c18:View Vector

def c16, 1, 0, 0, 1
def c17, 0, 0, 1, 1
def c18, 0, 0, -1, 0

// declare register data
dcl_position v0				//	v0 Vertex position
dcl_normal v4               //	v4 Vertex normal
dcl_texcoord0 v8            //	v8 Vertex texture coordinates

m4x4 r3, v0, c0		//	Transform vertices to Model-View-Projection space
mov oPos, r3		//

m3x3 r0, v4, c0		//	Transform the normal to Model-View-Projection space
dp3 r0.w, r0, r0	//	Renormalize for safety
rsq r0.w, r0.w
mul r0, r0, r0.w

dp3 r2, r0, c18	//	Dot(Normal,ViewVector): N.V
mov r4, c16		//	r4 = colour1
mov r5, c17		//	r5 = colour2
sub r6, r5, r4	//	(colour2 - colour1)
mul r7, r6, r2	//	interpolation*(colour2-colour1)
add r8, r7, r4	//	LERP = colour1 + interpolation*(colour2-colour1)

mov oD0, r8		//	Move final colour to output


